Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::FileWvOut Class Reference

STK audio file output class. More...

`#include <FileWvOut.h>`

Inheritance diagram for stk::FileWvOut:

## Public Member Functions

| FileWvOut (unsigned int bufferFrames=1024)
| Default constructor with optional output buffer size argument.
| FileWvOut (std::string fileName, unsigned int nChannels=1, FileWrite::FILE_TYPE type=FileWrite::FILE_WAV, Stk::StkFormat format=STK_SINT16, unsigned int bufferFrames=1024)
| Overloaded constructor used to specify a file name, type, and data format with this object.
virtual | ~FileWvOut ()
| Class destructor.
void | openFile (std::string fileName, unsigned int nChannels, FileWrite::FILE_TYPE type, Stk::StkFormat format)
| Open a new file with the specified parameters.
void | closeFile (void)
| Close a file if one is open.
void | tick (const StkFloat sample)
| Output a single sample to all channels in a sample frame.
void | tick (const StkFrames &frames)
| Output the StkFrames data.
Public Member Functions inherited from stk::WvOut
| WvOut (void)
| Default constructor.
unsigned long | getFrameCount (void) const
| Return the number of sample frames output.
StkFloat | getTime (void) const
| Return the number of seconds of data output.
bool | clipStatus (void)
| Returns `true` if clipping has been detected during output since instantiation or the last reset.
void | resetClipStatus (void)
| Reset the clipping status to `false`.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members

Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK audio file output class.

This class inherits from WvOut. It provides a "tick-level" interface to the FileWrite class.

FileWvOut writes samples to an audio file and supports multi-channel data. It is important to distinguish the tick() method that outputs a single sample to all channels in a sample frame from the overloaded one that takes a reference to an StkFrames object for multi-channel and/or multi-frame data.

See the FileWrite class for a description of the supported audio file formats.

Currently, FileWvOut is non-interpolating and the output rate is always Stk::sampleRate().

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Constructor & Destructor Documentation

## ◆ FileWvOut() [1/2]

stk::FileWvOut::FileWvOut | ( | unsigned int | bufferFrames = 1024 | ) |

Default constructor with optional output buffer size argument.

The output buffer size defines the number of frames that are accumulated between writes to disk.

## ◆ FileWvOut() [2/2]

stk::FileWvOut::FileWvOut | ( | std::string | fileName,
|  | unsigned int | nChannels = 1,
|  | FileWrite::FILE_TYPE | type = FileWrite::FILE_WAV,
|  | Stk::StkFormat | format = STK_SINT16,
|  | unsigned int | bufferFrames = 1024 )

Overloaded constructor used to specify a file name, type, and data format with this object.

An StkError is thrown for invalid argument values or if an error occurs when initializing the output file.

## Member Function Documentation

## ◆ openFile()

void stk::FileWvOut::openFile | ( | std::string | fileName,
|  | unsigned int | nChannels,
|  | FileWrite::FILE_TYPE | type,
|  | Stk::StkFormat | format )

Open a new file with the specified parameters.

If a file was previously open, it will be closed. An StkError will be thrown if any of the specified arguments are invalid or a file error occurs during opening.

## ◆ closeFile()

void stk::FileWvOut::closeFile | ( | void |  | ) |

Close a file if one is open.

Any data remaining in the internal buffer will be written to the file before closing.

## ◆ tick() [1/2]

void stk::FileWvOut::tick | ( | const StkFloat | sample | ) |

virtual

Output a single sample to all channels in a sample frame.

An StkError is thrown if an output error occurs.

Implements stk::WvOut.

## ◆ tick() [2/2]

void stk::FileWvOut::tick | ( | const StkFrames & | frames | ) |

virtual

Output the StkFrames data.

An StkError will be thrown if an output error occurs. An StkError will also be thrown if STK_DEBUG is defined during compilation and there is an incompatability between the number of channels in the FileWvOut object and that in the StkFrames object.

Implements stk::WvOut.

The documentation for this class was generated from the following file:

- FileWvOut.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.